SystemOrganization addCategory: #'Versionner-Cache'!
SystemOrganization addCategory: #'Versionner-Cache-Test'!

MCVersion subclass: #MBCacheVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Cache'!

MBCacheVersion subclass: #MBPackageCacheVersion
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Cache'!

!MBPackageCacheVersion methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 2/10/2012 12:37'!
fileOutOn: aStream with: aZip
	"write in zip project and dont flush the stream"
	| writer |
	writer := self writerClass on: aStream.
	writer packageName: (self info name).
	writer projectZip: aZip.
	writer writeVersion: self.! !

!MBPackageCacheVersion methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 2/10/2012 12:40'!
initializeWithPackage: aPackage info: aVersionInfo snapshot: aSnapshot dependencies: aCollection
	package := aPackage.
	info := aVersionInfo.
	snapshot := aSnapshot.
	dependencies := aCollection.! !

!MBPackageCacheVersion methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 11:15'!
writerClass
 	^ MBPackageCacheWriter ! !

MBCacheVersion subclass: #MBProjectCacheVersion
	instanceVariableNames: 'packageNames projectName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Cache'!

!MBProjectCacheVersion class methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalAlcocer 3/24/2012 20:41'!
named: nameString message: messageString autor: autorString
	^ MBProjectCacheVersion new
			setPackage:  (MCPackage new name: nameString)
			info: (MCVersionInfo
				name: nameString
				id: UUID new
				message: messageString
				date: Date today
				time: Time now
				author: autorString
				ancestors: #())
			snapshot: (MCSnapshot fromDefinitions: (Array new))
			dependencies: #();
			projectName: nameString.! !

!MBProjectCacheVersion methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 3/6/2012 17:09'!
addPackageVersion: aPackageName
	""
	packageNames add: aPackageName.! !

!MBProjectCacheVersion methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 3/6/2012 18:43'!
fileOutOn: aStream
	| writer path|
	path := FileDirectory default pathName, '/package-cache/'.
	writer := self writerClass on: aStream.
	writer writeVersion: self.
	packageNames do:[ : aSpec| 
		[writer zip addFile: (path, aSpec file) as: (aSpec file)] 
		on: Error do:[  writer zip addFile: (path, aSpec name , '.mcz')  as: (aSpec name , '.mcz')]. ].
	writer flush.
	! !

!MBProjectCacheVersion methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 3/6/2012 17:43'!
initialize 
	super initialize.
	packageNames := OrderedCollection new.! !

!MBProjectCacheVersion methodsFor: 'as yet unclassified' stamp: 'JuanPabloSandovalA 3/6/2012 17:43'!
packageVersions
	^ packageNames.! !

!MBProjectCacheVersion methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 10:16'!
projectName
	^projectName! !

!MBProjectCacheVersion methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 10:16'!
projectName: aString
	projectName := aString! !

!MBProjectCacheVersion methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 11:15'!
writerClass
 	^ MBProjectCacheWriter! !

MBConfigurationInfoCommand subclass: #MBSaveAsCacheCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Cache'!

!MBSaveAsCacheCommand methodsFor: 'documentation' stamp: 'JPSA 2/6/2012 10:36'!
documentation 
	^ 'Add a new cache in the selected configuration'! !

!MBSaveAsCacheCommand methodsFor: 'execute' stamp: 'JuanPabloSandovalAlcocer 3/24/2012 21:17'!
execute
	| message projectCache|
	
	message := MBPlatform current multilineRequest: 'Enter message for cached version' initialAnswer: ''.
	message ifNil:[ ^ self.].
	self checkUserInRepositoryOfPackage: self configurationClass name asString.
	projectCache := 
	MBProjectCacheVersion 
		named: ('Cache-' , self configurationClass name asString, '-' , Time millisecondClockValue asString)  
		message: message  
		autor: target version author. 
	(self filesOf: target) do:[ : p |  projectCache addPackageVersion: p].
	self repository storeVersion: projectCache.! !

!MBSaveAsCacheCommand methodsFor: 'accessing' stamp: 'JuanPabloSandovalAlcocer 3/24/2012 21:18'!
filesOf: aConfiguration
	"
	(ConfigurationOfMondrian project lastVersion  allPackagesForSpecNamed: 'ALL') collect: [ :pfs|  pfs file]
	"
	^ (aConfiguration currentVersion allPackagesForSpecNamed: 'ALL').! !

!MBSaveAsCacheCommand methodsFor: 'accessing' stamp: 'JPSA 2/6/2012 11:28'!
repository
	"Return the repository of the configuration. Create one (using UI) if necessary"

	^self chooseRepositoryFromList: target repositories! !

!MBSaveAsCacheCommand methodsFor: 'accessing' stamp: 'JPSA 2/6/2012 10:37'!
title
	^ 'save all and add new cache version'! !

MCMczWriter subclass: #MBCacheWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Cache'!

MBCacheWriter subclass: #MBPackageCacheWriter
	instanceVariableNames: 'packageName projectZip'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Cache'!

!MBPackageCacheWriter methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 10:17'!
addString: string at: path
	| member |
	member := projectZip addString: string as: path.
	member desiredCompressionMethod: ZipArchive compressionDeflated 
	! !

!MBPackageCacheWriter methodsFor: 'accessing' stamp: 'JPSA 2/6/2012 10:17'!
packageName
	^ packageName! !

!MBPackageCacheWriter methodsFor: 'accessing' stamp: 'JPSA 2/6/2012 10:17'!
packageName: anObject
	packageName := anObject! !

!MBPackageCacheWriter methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 10:17'!
projectZip: aZip
	projectZip := aZip.! !

!MBPackageCacheWriter methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 10:17'!
writePackage: aPackage
	self addString: (self serializePackage: aPackage) at: (packageName, '/package')! !

!MBPackageCacheWriter methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 10:17'!
writeSnapshot: aSnapshot
	self addString: (self serializeDefinitions: aSnapshot definitions) at: (packageName,'/snapshot/source.'), self snapshotWriterClass extension.
	self addString: (self serializeInBinary: aSnapshot) at: (packageName ,'/snapshot.bin')! !

!MBPackageCacheWriter methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 10:17'!
writeVersionDependency: aVersionDependency
	| string |
	string := (self serializeVersionInfo: aVersionDependency versionInfo).
	self addString: string at: (packageName,'/dependencies/'), aVersionDependency package name! !

!MBPackageCacheWriter methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 10:17'!
writeVersionInfo: aVersionInfo
	| string |
	string := self serializeVersionInfo: aVersionInfo.
	self addString: string at: (packageName , '/version').
! !

MBCacheWriter subclass: #MBProjectCacheWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Cache'!

TestCase subclass: #TestCache
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Cache-Test'!

MCMczReader subclass: #MBCacheReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Versionner-Cache'!

!MBCacheReader class methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 21:02'!
allDirectoriesOn: zip
	^ zip members select: [ :m | m isDirectory ].! !

!MBCacheReader class methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 21:26'!
allPackagesOn: zip
	^ (self allDirectoriesOn: zip) select: [ : d |    ('*snapshot*' match: (d fileName) ) not ].! !

!MBCacheReader class methodsFor: 'as yet unclassified' stamp: 'JPSA 2/6/2012 21:28'!
loadVersionFile: fileName
	| cacheVersion packages|
	cacheVersion := self versionFromFile: fileName.
	packages := self allPackageNamesOn: cacheVersion zip.
	packages do:[ : fn |  
		|version|
		version := MCMczReader versionFromStream: fn contentStream.
		version workingCopy repositoryGroup addRepository:
		(MCDirectoryRepository new directory:
			(FileDirectory on: (FileDirectory dirPathFor: fileName))).
		version load. ].
	
! !
